// $Id$

//=============================================================================
/**
 *  @file  trigger.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_BEE_TRIGGER_H
#define JYUGEM_BEE_TRIGGER_H

#include "ace/Message_Queue.h"
#include "ace/Method_Request.h"
#include "ace/Activation_Queue.h"
#include "jyugem/bee.h"
#include "jyugem/bee/command.h"

namespace bee = jyugem::bee;

namespace jyugem { namespace bee
{

class task;

//
// Trigger class
//
class BEE_Export trigger : public bee::command
{
  friend class trigger_request;
  
public:
  trigger(const std::string& cmd, bee::task * src = null)
    : bee::command(cmd), m_task(src), m_date(true) {}
  trigger(const trigger& rhs) { this->copy(rhs); }
  virtual ~trigger() {}

  trigger& operator=(const trigger& rhs)
  {
    if (this == &rhs)
      return *this;
    this->copy(rhs);
    return *this;
  }

  bee::datetime& date() { return m_date; }

// member methods
protected:
  trigger() : m_task(null), m_date(false) {}
  void copy(const trigger& rhs)
  {
    this->command::copy(rhs);
    m_task = rhs.m_task;
    m_date = rhs.m_date;
  }

// member variables
protected:
  bee::task *   m_task;
  bee::datetime m_date;
};


} } // *namespace* - jyugem::bee

#endif  /* JYUGEM_BEE_TRIGGER_H */
