/* $Id$ */

//=============================================================================
/**
 *  @file    uuid.h
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUBEM_BEE_UUID_H
#define JYUBEM_BEE_UUID_H

#include "jyugem/bee.h"
#include "ace/UUID.h"

namespace jyugem { namespace bee
{

//
//
class BEE_Export uuid : public ACE_Utils::UUID
{
public:
  uuid()
  {
    ACE_Utils::UUID_GENERATOR::instance()->generateUUID(m_uuid);
  }
  uuid(const std::string& uuid_string) : m_uuid(uuid_string.c_str()) {}
  ~uuid() {}

  static void init()
  {
    ACE_Utils::UUID_GENERATOR::instance()->init();
  }

protected:
  ACE_Utils::UUID m_uuid;
};

} } // *namespace* jyugem::bee

#endif  /* JYUGEM_BEE_UUID_H */
