// $Id$

//=============================================================================
/**
 *  @file    metadata_t.cpp
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 1998-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#define BEE_BUILD_DLL

#include <boost/lexical_cast.hpp>
#include "jyugem/bee.h"
#include "meta_template.h"
using namespace jyugem::bee;
namespace bee = jyugem::bee;


namespace jyugem { namespace bee
{

//
// Entity meta data
//
static meta_bool        entity_bool;
static meta_char        entity_char;
static meta_byte        entity_byte;
static meta_short       entity_short;
static meta_ushort      entity_ushort;
static meta_int         entity_int;
static meta_uint        entity_uint;
static meta_longlong    entity_longlong;
static meta_ulonglong   entity_ulonglong;
static meta_float       entity_float;
static meta_double      entity_double;
static meta_string      entity_string;
static meta_binary      entity_binary;
static plural_char      entity_chars;
static plural_short     entity_shorts;
static plural_ushort    entity_ushorts;
static plural_int       entity_ints;
static plural_uint      entity_uints;
static plural_longlong  entity_longlongs;
static plural_ulonglong entity_ulonglongs;
static plural_float     entity_floats;
static plural_double    entity_doubles;
static meta_array       entity_array;
static meta_struct      entity_struct;

static metadata * _metadata_table[32] =
{
  null,                   // 0
  &entity_char,           // 1
  &entity_short,          // 2
  &entity_int,            // 3
  &entity_longlong,       // 4
  &entity_byte,           // 5
  &entity_ushort,         // 6
  &entity_uint,           // 7
  &entity_ulonglong,      // 8
  &entity_float,          // 9
  &entity_double,         // 10
  &entity_bool,           // 11
  &entity_string,         // 12
  null,                   // 13
  null,                   // 14
  null,                   // 15
  null,                   // 16
  &entity_chars,          // 17
  &entity_shorts,         // 18
  &entity_ints,           // 19
  &entity_longlongs,      // 20
  &entity_binary,         // 21
  &entity_ushorts,        // 22
  &entity_uints,          // 23
  &entity_ulonglongs,     // 24
  &entity_floats,         // 25
  &entity_doubles,        // 26
  null,                   // 27
  null,                   // 28
  null,                   // 29
  &entity_array,          // 30
  &entity_struct,         // 31
};


metadata * metadata::instance(int t)
{
  if (t == 0 || t > BEE_STRUCT)
  {
    return null;
  }
  return _metadata_table[t];
}

} }  // *namespace* - jyugem::bee
