// $Id$

//=============================================================================
/**
 *  @file    ControlJob.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#define BEE_BUILD_DLL

#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif

#include "state/ControlJobState.h"
#include "jyugem/gem/event_manager.h"
#include "jyugem/cjm/ControlJob.h"

namespace bee = jyugem::bee;
namespace gem = jyugem::gem;

//
namespace jyugem { namespace cjm
{

//
// Control Job
//

ControlJob::ControlJob() : bee::state_task("ControlJob"), m_CurrentPRJob(null),
    m_DataCollectionPlan(_TX("")),  m_MtrlOutSpec(null),
    m_MtrlOutbyStatus(null), m_ProcessingCtrlSpec(0), m_ProcessOrderMgmt(LIST),
    m_StartMethod(false), m_State(0)
{
    ControlJobState * cjm = new ControlJobState(this);
    m_status = cjm;
    cjm->initiate();
}

ControlJob::~ControlJob()
{
    ControlJobState * cjm = static_cast<ControlJobState *>(m_status);
    cjm->terminate();
}

#if 0
void ControlJob::copy(const ControlJob& rhs)
{
    this->bee::state_task::operator =(rhs);
    m_CurrentPRJob = rhs.m_CurrentPRJob;
    m_DataCollectionPlan = rhs.m_DataCollectionPlan;
    m_CarrierInputSpec = rhs.m_CarrierInputSpec;
    m_MtrlOutSpec = rhs.m_MtrlOutSpec;
    m_MtrlOutbyStatus = rhs.m_MtrlOutbyStatus;
    m_PauseEvent = rhs.m_PauseEvent;
    m_ProcessingCtrlSpec = rhs.m_ProcessingCtrlSpec;
    m_ProcessOrderMgmt = rhs.m_ProcessOrderMgmt;
    m_StartMethod = rhs.m_StartMethod;
    m_State = rhs.m_State;
    m_status = new ControlJobState(this);
    //
    // transit current_state();
    //
}
#endif

gem::event_manager evtmngr;

int ControlJob::open0()
{
    ace::init();

    int result = this->open(null);
    this->on_trigger_connect(boost::bind(&gem::event_manager::notify, &evtmngr, _1, _2));

    return result;
}

const BCHAR * ControlJob::current_state()
{
    ControlJobState * cjbs = static_cast<ControlJobState *>(m_status);
    return cjbs->current_state();
}


} }  // namespace

#if 0  // OBSOLETE

namespace CJM = jyugem::cjm;

std::string GetEvent()
{
    std::string key;
    std::cin >> key;
    return key;
}


int main( int argc, char * argv[] )
{
    argc;
    argv;

    if (ACE_LOG_MSG->open(_TX("JYUGEM"), ACE_Log_Msg::LOGGER,
                          ACE_DEFAULT_LOGGER_KEY) != -1)
    {
        std::cout << "Logging open error\n";
    }

    std::cout << "boost::cjm ControlJob example\n\n";
    std::cout << "abort<CR>: Abort control job\n";
    std::cout << "begin<CR>: Begins work to be control job\n";
    std::cout << "cancel<CR>: Cancels control job\n";
    std::cout << "deselect<CR>: Deselects control job\n";
    std::cout << "complete<CR>: Completes process\n";
    std::cout << "hoq<CR>: Queue control job to head\n";
    std::cout << "pause<CR>: Pauses control job\n";
    std::cout << "resume<CR>: Resumes controj job\n";
    std::cout << "start<CR>: Starts control job\n";
    std::cout << "stop<CR>: Stops control job\n";
    std::cout << "quit<CR>: Quits the program\n\n";

    CJM::ControlJob cjb;
    cjb.open();
    gem::event_manager evtmngr;

    cjb.on_trigger_connect(boost::bind(&gem::event_manager::notify, &evtmngr, _1, _2));

    std::string key = GetEvent();
    while ( key != "quit" )
    {
        if ( key == "state" )
        {
            std::cout << "current state = " << cjb.current_state()
                      << std::endl;
        }
        else
        {   // Notify trigger
            bee::trigger * trig = new bee::trigger(key);
            if (cjb.notify(trig, null) < 0)
            {
                std::cout << "Invalid key!\n";
            }
        }
        key = GetEvent();
    }

    cjb.close();

    return 0;
}

#endif
